ServerEvents.recipes(event => {
    event.remove({ id: 'bloodmagic:blood_rune_blank' })
    event.shaped(
        Item.of('bloodmagic:blankrune'),
        [
            'ABA',
            'CDC',
            'AAA'
        ],
        {
            A: 'minecraft:deepslate',
            B: 'botania:rune_mana',
            C: 'bloodmagic:blankslate',
            D: [
                'bloodmagic:masterbloodorb',
                'bloodmagic:magicianbloodorb',
                'bloodmagic:apprenticebloodorb',
                'bloodmagic:weakbloodorb',
                'bloodmagic:archmagebloodorb'
            ]
        }
    )
    event.remove({ id: 'bloodmagic:blood_rune_displacement' })
    event.shaped(
        Item.of('bloodmagic:dislocationrune'),
        [
            'ABA',
            'BCB',
            'ADA'
        ],
        {
            A: '#forge:stone',
            B: 'minecraft:water_bucket',
            C: 'bloodmagic:blankrune',
            D: 'bloodmagic:reinforcedslate'
        }
    )
    event.remove({ id: 'bloodmagic:blood_rune_capacity' })
    event.shaped(
        Item.of('bloodmagic:altarcapacityrune'),
        [
            'ABA',
            'BCB',
            'ADA'
        ],
        {
            A: '#forge:stone',
            B: 'minecraft:bucket',
            C: 'bloodmagic:blankrune',
            D: 'bloodmagic:reinforcedslate'
        }
    )
    event.remove({ id: 'bloodmagic:blood_rune_aug_capacity' })
    event.shaped(
        Item.of('bloodmagic:bettercapacityrune'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: 'minecraft:obsidian',
            B: 'bloodmagic:infusedslate',
            C: 'minecraft:bucket',
            D: 'bloodmagic:blankrune',
            E: [
                'bloodmagic:masterbloodorb',
                'bloodmagic:magicianbloodorb',
                'bloodmagic:apprenticebloodorb',
                'bloodmagic:weakbloodorb',
                'bloodmagic:archmagebloodorb'
            ]
        }
    )
    event.remove({ output: 'bloodmagic:soulforge' })
    event.shaped(
        Item.of('bloodmagic:soulforge'),
        [
            'A A',
            'BCB',
            'BDB'
        ],
        {
            A: Item.of('bloodmagic:basemonstersoul'),
            B: 'bloodmagic:blankrune',
            C: 'bloodmagic:etherealslate',
            D: 'mna:runeforge'
        }
    )
    event.remove({ output: 'bloodmagic:alchemytable' })
    event.shaped(
        Item.of('bloodmagic:alchemytable'),
        [
            'AAA',
            'BCB',
            'DED'
        ],
        {
            A: 'bloodmagic:ritualstone',
            B: '#minecraft:planks',
            C: 'bloodmagic:archmagebloodorb',
            D: 'bloodmagic:etherealslate',
            E: 'mna:basic_table'
        }
    )
    event.remove({ output: 'bloodmagic:masterritualstone' })
    event.shaped(
        Item.of('bloodmagic:masterritualstone'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'bloodmagic:etherealslate',
            B: 'bloodmagic:ritualstone',
            C: [
                'bloodmagic:masterbloodorb',
                'bloodmagic:archmagebloodorb'
            ]
        }
    )
    event.shaped(
        Item.of('bloodmagic:hellforgedparts', 3),
        [
            'ABA',
            'BCB',
            'ABD'
        ],
        {
            A: 'bloodmagic:defaultcrystal',
            B: 'bloodmagic:ingot_hellforged',
            C: 'bloodmagic:hellforgedparts',
            D: 'bloodmagic:noderouter'
        }
    )
})